diff --git a/compiler/coreSyn/CoreLint.lhs b/compiler/coreSyn/CoreLint.lhs
index 2b76a4a..3222ee7 100644
--- a/compiler/coreSyn/CoreLint.lhs
+++ b/compiler/coreSyn/CoreLint.lhs
@@ -7,12 +7,6 @@
 A ``lint'' pass to check for Core correctness
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 {-# OPTIONS_GHC -fprof-auto #-}
 
@@ -70,9 +64,9 @@ the Core language (all signposted to this note), you should update that
 formalism. See docs/core-spec/README for more info about how to do so.
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection[lintCoreBindings]{@lintCoreBindings@: Top-level interface}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 Checks that a set of core bindings is well-formed.  The PprStyle and String
@@ -81,13 +75,13 @@ indicates whether we have done any specialisation yet (in which case we do
 some extra checks).
 
 We check for
-	(a) type errors
-	(b) Out-of-scope type variables
-	(c) Out-of-scope local variables
-	(d) Ill-kinded types
+        (a) type errors
+        (b) Out-of-scope type variables
+        (c) Out-of-scope local variables
+        (d) Ill-kinded types
 
 If we have done specialisation the we check that there are
-	(a) No top-level bindings of primitive (unboxed type)
+        (a) No top-level bindings of primitive (unboxed type)
 
 Outstanding issues:
 
@@ -103,13 +97,13 @@ Outstanding issues:
 Note [Linting type lets]
 ~~~~~~~~~~~~~~~~~~~~~~~~
 In the desugarer, it's very very convenient to be able to say (in effect)
-	let a = Type Int in <body>
+        let a = Type Int in <body>
 That is, use a type let.   See Note [Type let] in CoreSyn.
 
 However, when linting <body> we need to remember that a=Int, else we might
 reject a correct program.  So we carry a type substitution (in this example 
 [a -> Int]) and apply this substitution before comparing types.  The functin
-	lintInTy :: Type -> LintM Type
+        lintInTy :: Type -> LintM Type
 returns a substituted type; that's the only reason it returns anything.
 
 When we encounter a binder (like x::a) we must apply the substitution
@@ -130,9 +124,9 @@ lintCoreBindings local_in_scope binds
     addLoc TopLevelBindings        $
     addInScopeVars local_in_scope  $
     addInScopeVars binders         $
-	-- Put all the top-level binders in scope at the start
-	-- This is because transformation rules can bring something
-	-- into use 'unexpectedly'
+        -- Put all the top-level binders in scope at the start
+        -- This is because transformation rules can bring something
+        -- into use 'unexpectedly'
     do { checkL (null dups) (dupVars dups)
        ; checkL (null ext_dups) (dupExtVars ext_dups)
        ; mapM lint_bind binds }
@@ -154,14 +148,14 @@ lintCoreBindings local_in_scope binds
 
     -- If you edit this function, you may need to update the GHC formalism
     -- See Note [GHC Formalism]
-    lint_bind (Rec prs)		= mapM_ (lintSingleBinding TopLevel Recursive) prs
+    lint_bind (Rec prs)         = mapM_ (lintSingleBinding TopLevel Recursive) prs
     lint_bind (NonRec bndr rhs) = lintSingleBinding TopLevel NonRecursive (bndr,rhs)
 \end{code}
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection[lintUnfolding]{lintUnfolding}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 We use this to check all unfoldings that come in from interfaces
@@ -169,35 +163,35 @@ We use this to check all unfoldings that come in from interfaces
 
 \begin{code}
 lintUnfolding :: SrcLoc
-	      -> [Var]		-- Treat these as in scope
-	      -> CoreExpr
-	      -> Maybe MsgDoc	-- Nothing => OK
+              -> [Var]          -- Treat these as in scope
+              -> CoreExpr
+              -> Maybe MsgDoc   -- Nothing => OK
 
 lintUnfolding locn vars expr
   | isEmptyBag errs = Nothing
   | otherwise       = Just (pprMessageBag errs)
   where
     (_warns, errs) = initL (addLoc (ImportedUnfolding locn) $
-                            addInScopeVars vars	           $
+                            addInScopeVars vars            $
                             lintCoreExpr expr)
 
-lintExpr :: [Var]		-- Treat these as in scope
-	 -> CoreExpr
-	 -> Maybe MsgDoc	-- Nothing => OK
+lintExpr :: [Var]               -- Treat these as in scope
+         -> CoreExpr
+         -> Maybe MsgDoc        -- Nothing => OK
 
 lintExpr vars expr
   | isEmptyBag errs = Nothing
   | otherwise       = Just (pprMessageBag errs)
   where
     (_warns, errs) = initL (addLoc TopLevelBindings $
-                            addInScopeVars vars	    $
+                            addInScopeVars vars     $
                             lintCoreExpr expr)
 \end{code}
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection[lintCoreBinding]{lintCoreBinding}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 Check a core binding, returning the list of variables bound.
@@ -209,7 +203,7 @@ lintSingleBinding :: TopLevelFlag -> RecFlag -> (Id, CoreExpr) -> LintM ()
 lintSingleBinding top_lvl_flag rec_flag (binder,rhs)
   = addLoc (RhsOf binder) $
          -- Check the rhs 
-    do { ty <- lintCoreExpr rhs	
+    do { ty <- lintCoreExpr rhs 
        ; lintBinder binder -- Check match to RHS type
        ; binder_ty <- applySubstTy binder_ty
        ; checkTys binder_ty ty (mkRhsMsg binder (ptext (sLit "RHS")) ty)
@@ -217,7 +211,7 @@ lintSingleBinding top_lvl_flag rec_flag (binder,rhs)
         -- Check (not isUnLiftedType) (also checks for bogus unboxed tuples)
        ; checkL (not (isUnLiftedType binder_ty)
             || (isNonRec rec_flag && exprOkForSpeculation rhs))
- 	   (mkRhsPrimMsg binder rhs)
+           (mkRhsPrimMsg binder rhs)
 
         -- Check that if the binder is top-level or recursive, it's not demanded
        ; checkL (not (isStrictId binder)
@@ -236,7 +230,7 @@ lintSingleBinding top_lvl_flag rec_flag (binder,rhs)
 
        ; when (isStrongLoopBreaker (idOccInfo binder) && isInlinePragma (idInlinePragma binder))
               (addWarnL (ptext (sLit "INLINE binder is (non-rule) loop breaker:") <+> ppr binder))
-	      -- Only non-rule loop breakers inhibit inlining
+              -- Only non-rule loop breakers inhibit inlining
 
       -- Check whether arity and demand type are consistent (only if demand analysis
       -- already happened)
@@ -245,9 +239,9 @@ lintSingleBinding top_lvl_flag rec_flag (binder,rhs)
            (mkArityMsg binder)
 
        ; lintIdUnfolding binder binder_ty (idUnfolding binder) }
-	  
-	-- We should check the unfolding, if any, but this is tricky because
- 	-- the unfolding is a SimplifiableCoreExpr. Give up for now.
+          
+        -- We should check the unfolding, if any, but this is tricky because
+        -- the unfolding is a SimplifiableCoreExpr. Give up for now.
    where
     binder_ty                  = idType binder
     dmdTy                      = idStrictness binder
@@ -256,7 +250,7 @@ lintSingleBinding top_lvl_flag rec_flag (binder,rhs)
     -- If you edit this function, you may need to update the GHC formalism
     -- See Note [GHC Formalism]
     lintBinder var | isId var  = lintIdBndr var $ \_ -> (return ())
-	           | otherwise = return ()
+                   | otherwise = return ()
 
 lintIdUnfolding :: Id -> Type -> Unfolding -> LintM ()
 lintIdUnfolding bndr bndr_ty (CoreUnfolding { uf_tmpl = rhs, uf_src = src })
@@ -268,23 +262,23 @@ lintIdUnfolding  _ _ _
 \end{code}
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection[lintCoreExpr]{lintCoreExpr}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
---type InKind      = Kind	-- Substitution not yet applied
-type InType      = Type	
+--type InKind      = Kind       -- Substitution not yet applied
+type InType      = Type 
 type InCoercion  = Coercion
 type InVar       = Var
 type InTyVar     = TyVar
 
-type OutKind     = Kind	-- Substitution has been applied to this,
+type OutKind     = Kind -- Substitution has been applied to this,
                         -- but has not been linted yet
 type LintedKind  = Kind -- Substitution applied, and type is linted
 
-type OutType     = Type	-- Substitution has been applied to this,
+type OutType     = Type -- Substitution has been applied to this,
                         -- but has not been linted yet
 
 type LintedType  = Type -- Substitution applied, and type is linted
@@ -296,21 +290,21 @@ type OutTyVar    = TyVar
 lintCoreExpr :: CoreExpr -> LintM OutType
 -- The returned type has the substitution from the monad 
 -- already applied to it:
---	lintCoreExpr e subst = exprType (subst e)
+--      lintCoreExpr e subst = exprType (subst e)
 --
 -- The returned "type" can be a kind, if the expression is (Type ty)
 
 -- If you edit this function, you may need to update the GHC formalism
 -- See Note [GHC Formalism]
 lintCoreExpr (Var var)
-  = do	{ checkL (not (var == oneTupleDataConId))
-		 (ptext (sLit "Illegal one-tuple"))
+  = do  { checkL (not (var == oneTupleDataConId))
+                 (ptext (sLit "Illegal one-tuple"))
 
         ; checkL (isId var && not (isCoVar var))
                  (ptext (sLit "Non term variable") <+> ppr var)
 
         ; checkDeadIdOcc var
-	; var' <- lookupIdInScope var
+        ; var' <- lookupIdInScope var
         ; return (idType var') }
 
 lintCoreExpr (Lit lit)
@@ -335,30 +329,30 @@ lintCoreExpr (Tick _other_tickish expr)
 
 lintCoreExpr (Let (NonRec tv (Type ty)) body)
   | isTyVar tv
-  =	-- See Note [Linting type lets]
-    do	{ ty' <- applySubstTy ty
+  =     -- See Note [Linting type lets]
+    do  { ty' <- applySubstTy ty
         ; lintTyBndr tv              $ \ tv' -> 
     do  { addLoc (RhsOf tv) $ checkTyKind tv' ty'
-		-- Now extend the substitution so we 
-		-- take advantage of it in the body
+                -- Now extend the substitution so we 
+                -- take advantage of it in the body
         ; extendSubstL tv' ty'       $ 
           addLoc (BodyOfLetRec [tv]) $ 
           lintCoreExpr body } }
 
 lintCoreExpr (Let (NonRec bndr rhs) body)
   | isId bndr
-  = do	{ lintSingleBinding NotTopLevel NonRecursive (bndr,rhs)
-	; addLoc (BodyOfLetRec [bndr]) 
-		 (lintAndScopeId bndr $ \_ -> (lintCoreExpr body)) }
+  = do  { lintSingleBinding NotTopLevel NonRecursive (bndr,rhs)
+        ; addLoc (BodyOfLetRec [bndr]) 
+                 (lintAndScopeId bndr $ \_ -> (lintCoreExpr body)) }
 
   | otherwise
-  = failWithL (mkLetErr bndr rhs)	-- Not quite accurate
+  = failWithL (mkLetErr bndr rhs)       -- Not quite accurate
 
 lintCoreExpr (Let (Rec pairs) body) 
-  = lintAndScopeIds bndrs	$ \_ ->
-    do	{ checkL (null dups) (dupVars dups)
-        ; mapM_ (lintSingleBinding NotTopLevel Recursive) pairs	
-	; addLoc (BodyOfLetRec bndrs) (lintCoreExpr body) }
+  = lintAndScopeIds bndrs       $ \_ ->
+    do  { checkL (null dups) (dupVars dups)
+        ; mapM_ (lintSingleBinding NotTopLevel Recursive) pairs 
+        ; addLoc (BodyOfLetRec bndrs) (lintCoreExpr body) }
   where
     bndrs = map fst pairs
     (_, dups) = removeDups compare bndrs
@@ -375,29 +369,29 @@ lintCoreExpr (Lam var expr)
     do { body_ty <- lintCoreExpr expr
        ; if isId var' then 
              return (mkFunTy (idType var') body_ty) 
-	 else
-	     return (mkForAllTy var' body_ty)
+         else
+             return (mkForAllTy var' body_ty)
        }
-	-- The applySubstTy is needed to apply the subst to var
+        -- The applySubstTy is needed to apply the subst to var
 
 lintCoreExpr e@(Case scrut var alt_ty alts) =
        -- Check the scrutinee
   do { scrut_ty <- lintCoreExpr scrut
      ; alt_ty   <- lintInTy alt_ty  
-     ; var_ty   <- lintInTy (idType var)	
+     ; var_ty   <- lintInTy (idType var)        
 
      ; case tyConAppTyCon_maybe (idType var) of 
          Just tycon
               | debugIsOn &&
                 isAlgTyCon tycon && 
-		not (isFamilyTyCon tycon || isAbstractTyCon tycon) &&
+                not (isFamilyTyCon tycon || isAbstractTyCon tycon) &&
                 null (tyConDataCons tycon) -> 
                   pprTrace "Lint warning: case binder's type has no constructors" (ppr var <+> ppr (idType var))
-			-- This can legitimately happen for type families
+                        -- This can legitimately happen for type families
                       $ return ()
          _otherwise -> return ()
 
-	-- Don't use lintIdBndr on var, because unboxed tuple is legitimate
+        -- Don't use lintIdBndr on var, because unboxed tuple is legitimate
 
      ; subst <- getTvSubst 
      ; checkTys var_ty scrut_ty (mkScrutMsg var var_ty scrut_ty subst)
@@ -439,9 +433,9 @@ applied in the type variables:
   k_ag   ~~>   * -> *
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection[lintCoreArgs]{lintCoreArgs}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 The basic version of these functions checks that the argument is a
@@ -459,7 +453,7 @@ lintCoreArg fun_ty arg
 
 -----------------
 lintAltBinders :: OutType     -- Scrutinee type
-	       -> OutType     -- Constructor type
+               -> OutType     -- Constructor type
                -> [OutVar]    -- Binders
                -> LintM ()
 -- If you edit this function, you may need to update the GHC formalism
@@ -479,7 +473,7 @@ lintTyApp :: OutType -> OutType -> LintM OutType
 lintTyApp fun_ty arg_ty
   | Just (tyvar,body_ty) <- splitForAllTy_maybe fun_ty
   , isTyVar tyvar
-  = do	{ checkTyKind tyvar arg_ty
+  = do  { checkTyKind tyvar arg_ty
         ; return (substTyWith [tyvar] [arg_ty] body_ty) }
 
   | otherwise
@@ -507,10 +501,10 @@ checkTyKind :: OutTyVar -> OutType -> LintM ()
 checkTyKind tyvar arg_ty
   | isSuperKind tyvar_kind  -- kind forall
   = lintKind arg_ty
-	-- Arg type might be boxed for a function with an uncommitted
-	-- tyvar; notably this is used so that we can give
-	-- 	error :: forall a:*. String -> a
-	-- and then apply it to both boxed and unboxed types.
+        -- Arg type might be boxed for a function with an uncommitted
+        -- tyvar; notably this is used so that we can give
+        --      error :: forall a:*. String -> a
+        -- and then apply it to both boxed and unboxed types.
   | otherwise  -- type forall
   = do { arg_kind <- lintType arg_ty
        ; unless (arg_kind `isSubKind` tyvar_kind)
@@ -525,16 +519,16 @@ checkDeadIdOcc id
   | isDeadOcc (idOccInfo id)
   = do { in_case <- inCasePat
        ; checkL in_case
-		(ptext (sLit "Occurrence of a dead Id") <+> ppr id) }
+                (ptext (sLit "Occurrence of a dead Id") <+> ppr id) }
   | otherwise
   = return ()
 \end{code}
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection[lintCoreAlts]{lintCoreAlts}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -551,11 +545,11 @@ checkCaseAlts e ty alts =
   do { checkL (all non_deflt con_alts) (mkNonDefltMsg e)
      ; checkL (increasing_tag con_alts) (mkNonIncreasingAltsMsg e)
      ; checkL (isJust maybe_deflt || not is_infinite_ty)
-	   (nonExhaustiveAltsMsg e) }
+           (nonExhaustiveAltsMsg e) }
   where
     (con_alts, maybe_deflt) = findDefault alts
 
-	-- Check that successive alternatives have increasing tags 
+        -- Check that successive alternatives have increasing tags 
     increasing_tag (alt1 : rest@( alt2 : _)) = alt1 `ltAlt` alt2 && increasing_tag rest
     increasing_tag _                         = True
 
@@ -573,10 +567,10 @@ checkAltExpr expr ann_ty
   = do { actual_ty <- lintCoreExpr expr 
        ; checkTys actual_ty ann_ty (mkCaseAltMsg expr actual_ty ann_ty) }
 
-lintCoreAlt :: OutType 		-- Type of scrutinee
+lintCoreAlt :: OutType          -- Type of scrutinee
             -> OutType          -- Type of the alternative
-	    -> CoreAlt
-	    -> LintM ()
+            -> CoreAlt
+            -> LintM ()
 -- If you edit this function, you may need to update the GHC formalism
 -- See Note [GHC Formalism]
 lintCoreAlt _ alt_ty (DEFAULT, args, rhs) =
@@ -599,24 +593,24 @@ lintCoreAlt scrut_ty alt_ty alt@(DataAlt con, args, rhs)
   | Just (tycon, tycon_arg_tys) <- splitTyConApp_maybe scrut_ty
   = addLoc (CaseAlt alt) $  do
     {   -- First instantiate the universally quantified 
-	-- type variables of the data constructor
-	-- We've already check
+        -- type variables of the data constructor
+        -- We've already check
       checkL (tycon == dataConTyCon con) (mkBadConMsg tycon con)
     ; let con_payload_ty = applyTys (dataConRepType con) tycon_arg_tys
 
-	-- And now bring the new binders into scope
+        -- And now bring the new binders into scope
     ; lintBinders args $ \ args' -> do
     { addLoc (CasePat alt) (lintAltBinders scrut_ty con_payload_ty args')
     ; checkAltExpr rhs alt_ty } }
 
-  | otherwise	-- Scrut-ty is wrong shape
+  | otherwise   -- Scrut-ty is wrong shape
   = addErrL (mkBadAltMsg scrut_ty alt)
 \end{code}
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection[lint-types]{Types}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -627,8 +621,8 @@ lintCoreAlt scrut_ty alt_ty alt@(DataAlt con, args, rhs)
 lintBinders :: [Var] -> ([Var] -> LintM a) -> LintM a
 lintBinders [] linterF = linterF []
 lintBinders (var:vars) linterF = lintBinder var $ \var' ->
-				 lintBinders vars $ \ vars' ->
-				 linterF (var':vars')
+                                 lintBinders vars $ \ vars' ->
+                                 linterF (var':vars')
 
 -- If you edit this function, you may need to update the GHC formalism
 -- See Note [GHC Formalism]
@@ -650,7 +644,7 @@ lintIdBndr :: Id -> (Id -> LintM a) -> LintM a
 -- ToDo: lint its rules
 
 lintIdBndr id linterF 
-  = do 	{ lintAndScopeId id $ \id' -> linterF id' }
+  = do  { lintAndScopeId id $ \id' -> linterF id' }
 
 lintAndScopeIds :: [Var] -> ([Var] -> LintM a) -> LintM a
 lintAndScopeIds ids linterF 
@@ -670,9 +664,9 @@ lintAndScopeId id linterF
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
              Types and kinds
-%*									*
+%*                                                                      *
 %************************************************************************
 
 We have a single linter for types and kinds.  That is convenient
@@ -686,9 +680,9 @@ lintInTy :: InType -> LintM LintedType
 -- See Note [Linting type lets]
 lintInTy ty 
   = addLoc (InType ty) $
-    do	{ ty' <- applySubstTy ty
-	; _k  <- lintType ty'
-	; return ty' }
+    do  { ty' <- applySubstTy ty
+        ; _k  <- lintType ty'
+        ; return ty' }
 
 -------------------
 lintTyBndrKind :: OutTyVar -> LintM ()
@@ -811,9 +805,9 @@ lint_app doc kfn kas
 \end{code}
 
 %************************************************************************
-%*									*
+%*                                                                      *
          Linting coercions
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -947,7 +941,7 @@ lintCoercion (InstCo co arg_ty)
                           substTyWith [tv2] [arg_ty] ty2, r) 
             | otherwise
             -> failWithL (ptext (sLit "Kind mis-match in inst coercion"))
-	  _ -> failWithL (ptext (sLit "Bad argument of inst")) }
+          _ -> failWithL (ptext (sLit "Bad argument of inst")) }
 
 lintCoercion co@(AxiomInstCo con ind cos)
   = do { unless (0 <= ind && ind < brListLength (coAxiomBranches con))
@@ -1038,9 +1032,9 @@ lintCoercion this@(AxiomRuleCo co ts cs)
 \end{code}
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection[lint-monad]{The Lint monad}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -1051,25 +1045,25 @@ newtype LintM a =
    LintM { unLintM :: 
             [LintLocInfo] ->         -- Locations
             TvSubst ->               -- Current type substitution; we also use this
-				     -- to keep track of all the variables in scope,
-				     -- both Ids and TyVars
-	    WarnsAndErrs ->           -- Error and warning messages so far
-	    (Maybe a, WarnsAndErrs) } -- Result and messages (if any)
+                                     -- to keep track of all the variables in scope,
+                                     -- both Ids and TyVars
+            WarnsAndErrs ->           -- Error and warning messages so far
+            (Maybe a, WarnsAndErrs) } -- Result and messages (if any)
 
 type WarnsAndErrs = (Bag MsgDoc, Bag MsgDoc)
 
-{-	Note [Type substitution]
-	~~~~~~~~~~~~~~~~~~~~~~~~
+{-      Note [Type substitution]
+        ~~~~~~~~~~~~~~~~~~~~~~~~
 Why do we need a type substitution?  Consider
-	/\(a:*). \(x:a). /\(a:*). id a x
+        /\(a:*). \(x:a). /\(a:*). id a x
 This is ill typed, because (renaming variables) it is really
-	/\(a:*). \(x:a). /\(b:*). id b x
+        /\(a:*). \(x:a). /\(b:*). id b x
 Hence, when checking an application, we can't naively compare x's type
 (at its binding site) with its expected type (at a use site).  So we
 rename type binders as we go, maintaining a substitution.
 
 The same substitution also supports let-type, current expressed as
-	(/\(a:*). body) ty
+        (/\(a:*). body) ty
 Here we substitute 'ty' for 'a' in 'body', on the fly.
 -}
 
@@ -1090,15 +1084,15 @@ instance Monad LintM where
                            Nothing -> (Nothing, errs'))
 
 data LintLocInfo
-  = RhsOf Id		-- The variable bound
-  | LambdaBodyOf Id	-- The lambda-binder
-  | BodyOfLetRec [Id]	-- One of the binders
-  | CaseAlt CoreAlt	-- Case alternative
-  | CasePat CoreAlt	-- The *pattern* of the case alternative
-  | AnExpr CoreExpr	-- Some expression
+  = RhsOf Id            -- The variable bound
+  | LambdaBodyOf Id     -- The lambda-binder
+  | BodyOfLetRec [Id]   -- One of the binders
+  | CaseAlt CoreAlt     -- Case alternative
+  | CasePat CoreAlt     -- The *pattern* of the case alternative
+  | AnExpr CoreExpr     -- Some expression
   | ImportedUnfolding SrcLoc -- Some imported unfolding (ToDo: say which)
   | TopLevelBindings
-  | InType Type		-- Inside a type
+  | InType Type         -- Inside a type
   | InCo   Coercion     -- Inside a coercion
 \end{code}
 
@@ -1135,8 +1129,8 @@ addMsg subst msgs msg locs
    (loc, cxt1) = dumpLoc (head locs)
    cxts        = [snd (dumpLoc loc) | loc <- locs]   
    context     | opt_PprStyle_Debug = vcat (reverse cxts) $$ cxt1 $$
-				      ptext (sLit "Substitution:") <+> ppr subst
-	       | otherwise	    = cxt1
+                                      ptext (sLit "Substitution:") <+> ppr subst
+               | otherwise          = cxt1
  
    mk_msg msg = mkLocMessage SevWarning (mkSrcSpan loc loc) (context $$ msg)
 
@@ -1144,7 +1138,7 @@ addLoc :: LintLocInfo -> LintM a -> LintM a
 addLoc extra_loc m =
   LintM (\ loc subst errs -> unLintM m (extra_loc:loc) subst errs)
 
-inCasePat :: LintM Bool		-- A slight hack; see the unique call site
+inCasePat :: LintM Bool         -- A slight hack; see the unique call site
 inCasePat = LintM $ \ loc _ errs -> (Just (is_case_pat loc), errs)
   where
     is_case_pat (CasePat {} : _) = True
@@ -1183,18 +1177,18 @@ extendSubstL tv ty m
 lookupIdInScope :: Id -> LintM Id
 lookupIdInScope id 
   | not (mustHaveLocalBinding id)
-  = return id	-- An imported Id
-  | otherwise	
-  = do	{ subst <- getTvSubst
-	; case lookupInScope (getTvInScope subst) id of
-		Just v  -> return v
-		Nothing -> do { addErrL out_of_scope
-			      ; return id } }
+  = return id   -- An imported Id
+  | otherwise   
+  = do  { subst <- getTvSubst
+        ; case lookupInScope (getTvInScope subst) id of
+                Just v  -> return v
+                Nothing -> do { addErrL out_of_scope
+                              ; return id } }
   where
     out_of_scope = pprBndr LetBind id <+> ptext (sLit "is out of scope")
 
 
-oneTupleDataConId :: Id	-- Should not happen
+oneTupleDataConId :: Id -- Should not happen
 oneTupleDataConId = dataConWorkId (tupleCon BoxedTuple 1)
 
 checkBndrIdInScope :: Var -> Var -> LintM ()
@@ -1202,7 +1196,7 @@ checkBndrIdInScope binder id
   = checkInScope msg id
     where
      msg = ptext (sLit "is out of scope inside info for") <+> 
-	   ppr binder
+           ppr binder
 
 checkTyCoVarInScope :: Var -> LintM ()
 checkTyCoVarInScope v = checkInScope (ptext (sLit "is out of scope")) v
@@ -1232,9 +1226,9 @@ checkRole co r1 r2
 \end{code}
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{Error messages}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -1280,23 +1274,23 @@ pp_binder b | isId b    = hsep [ppr b, dcolon, ppr (idType b)]
 
 \begin{code}
 ------------------------------------------------------
---	Messages for case expressions
+--      Messages for case expressions
 
 mkDefaultArgsMsg :: [Var] -> MsgDoc
 mkDefaultArgsMsg args 
   = hang (text "DEFAULT case with binders")
-	 4 (ppr args)
+         4 (ppr args)
 
 mkCaseAltMsg :: CoreExpr -> Type -> Type -> MsgDoc
 mkCaseAltMsg e ty1 ty2
   = hang (text "Type of case alternatives not the same as the annotation on case:")
-	 4 (vcat [ppr ty1, ppr ty2, ppr e])
+         4 (vcat [ppr ty1, ppr ty2, ppr e])
 
 mkScrutMsg :: Id -> Type -> Type -> TvSubst -> MsgDoc
 mkScrutMsg var var_ty scrut_ty subst
   = vcat [text "Result binder in case doesn't match scrutinee:" <+> ppr var,
-	  text "Result binder type:" <+> ppr var_ty,--(idType var),
-	  text "Scrutinee type:" <+> ppr scrut_ty,
+          text "Result binder type:" <+> ppr var_ty,--(idType var),
+          text "Scrutinee type:" <+> ppr scrut_ty,
      hsep [ptext (sLit "Current TV subst"), ppr subst]]
 
 mkNonDefltMsg, mkNonIncreasingAltsMsg :: CoreExpr -> MsgDoc
@@ -1312,17 +1306,17 @@ nonExhaustiveAltsMsg e
 mkBadConMsg :: TyCon -> DataCon -> MsgDoc
 mkBadConMsg tycon datacon
   = vcat [
-	text "In a case alternative, data constructor isn't in scrutinee type:",
-	text "Scrutinee type constructor:" <+> ppr tycon,
-	text "Data con:" <+> ppr datacon
+        text "In a case alternative, data constructor isn't in scrutinee type:",
+        text "Scrutinee type constructor:" <+> ppr tycon,
+        text "Data con:" <+> ppr datacon
     ]
 
 mkBadPatMsg :: Type -> Type -> MsgDoc
 mkBadPatMsg con_result_ty scrut_ty
   = vcat [
-	text "In a case alternative, pattern result type doesn't match scrutinee type:",
-	text "Pattern result type:" <+> ppr con_result_ty,
-	text "Scrutinee type:" <+> ppr scrut_ty
+        text "In a case alternative, pattern result type doesn't match scrutinee type:",
+        text "Pattern result type:" <+> ppr con_result_ty,
+        text "Scrutinee type:" <+> ppr scrut_ty
     ]
 
 integerScrutinisedMsg :: MsgDoc
